# QCA::CRL Class Reference
[QCA user API]

Certificate Revocation List More...

`#include <QtCrypto>`

Inheritance diagram for QCA::CRL:

Collaboration diagram for QCA::CRL:

[legend]

List of all members.

## Public Member Functions

void | change (CRLContext *c)
| CRL (const CRL &from)
bool | isNull () const
CertificateInfo | issuerInfo () const
CertificateInfoOrdered | issuerInfoOrdered () const
QByteArray | issuerKeyId () const
QDateTime | nextUpdate () const
int | number () const
bool | operator!= (const CRL &other) const
CRL & | operator= (const CRL &from)
bool | operator== (const CRL &a) const
QList< CRLEntry > | revoked () const
SignatureAlgorithm | signatureAlgorithm () const
QDateTime | thisUpdate () const
QByteArray | toDER () const
QString | toPEM () const
bool | toPEMFile (const QString &fileName) const

## Static Public Member Functions

static CRL | fromDER (const QByteArray &a, ConvertResult *result=0, const QString &provider=QString())
static CRL | fromPEM (const QString &s, ConvertResult *result=0, const QString &provider=QString())
static CRL | fromPEMFile (const QString &fileName, ConvertResult *result=0, const QString &provider=QString())

## Friends

class | Private

## Detailed Description

Certificate Revocation List

A CRL is a list of certificates that are special in some way. The normal reason for including a certificate on a CRL is that the certificate should no longer be used. For example, if a key is compromised, then the associated certificate may no longer provides appropriate security. There are other reasons why a certificate may be placed on a CRL, as shown in the CRLEntry::Reason enumeration.

See also:
  CertificateCollection for a way to handle Certificates and CRLs as a single entity.

  CRLEntry for the CRL segment representing a single Certificate.

## Constructor & Destructor Documentation

QCA::CRL::CRL | ( | const CRL & | from | ) |

Standard copy constructor.

Parameters:

  | from | the revocation list to copy from

## Member Function Documentation

void QCA::CRL::change | ( | CRLContext * | c | ) |

For internal use only.

Parameters:

  | c | context (internal)

static CRL QCA::CRL::fromDER | ( | const QByteArray & | a,
|  | ConvertResult * | result = `0`,
|  | const QString & | provider = `QString()` |
| ) |  |  | `[static]`

Import a DER encoded Certificate Revocation List (CRL).

Parameters:

  | a | the array containing the CRL in DER format
  | result | a pointer to a ConvertResult, which if not-null will be set to the conversion status
  | provider | the provider to use, if a specific provider is required

Returns:
  the CRL corresponding to the contents of the array

static CRL QCA::CRL::fromPEM | ( | const QString & | s,
|  | ConvertResult * | result = `0`,
|  | const QString & | provider = `QString()` |
| ) |  |  | `[static]`

Import a PEM encoded Certificate Revocation List (CRL).

Parameters:

  | s | the string containing the CRL in PEM format
  | result | a pointer to a ConvertResult, which if not-null will be set to the conversion status
  | provider | the provider to use, if a specific provider is required

Returns:
  the CRL corresponding to the contents of the string

static CRL QCA::CRL::fromPEMFile | ( | const QString & | fileName,
|  | ConvertResult * | result = `0`,
|  | const QString & | provider = `QString()` |
| ) |  |  | `[static]`

Import a PEM encoded Certificate Revocation List (CRL) from a file.

Parameters:

  | fileName | the name (and path, if required) of the file containing the certificate in PEM format
  | result | a pointer to a ConvertResult, which if not-null will be set to the conversion status
  | provider | the provider to use, if a specific provider is required

Returns:
  the CRL in the file

bool QCA::CRL::isNull | ( |  | ) | const

Test if the CRL is empty.

Returns:
  true if the CRL is entry, otherwise return false

CertificateInfo QCA::CRL::issuerInfo | ( |  | ) | const

Information on the issuer of the CRL as a QMultiMap.

See also:
  issuerInfoOrdered for a version that maintains the order of information fields as per the underlying CRL.

CertificateInfoOrdered QCA::CRL::issuerInfoOrdered | ( |  | ) | const

Information on the issuer of the CRL as an ordered list (QList of CertificateInfoPair).

See also:
  issuerInfo for a version that allows lookup based on a multimap.

  CertificateInfoPair for the elements in the list

QByteArray QCA::CRL::issuerKeyId | ( |  | ) | const

The key identification of the CRL issuer.

QDateTime QCA::CRL::nextUpdate | ( |  | ) | const

the time that this CRL will be obsoleted

you should obtain an updated CRL at this time

int QCA::CRL::number | ( |  | ) | const

The CRL serial number.

Note that serial numbers are a CRL extension, and not all certificates have one.

Returns:
  the CRL serial number, or -1 if there is no serial number

bool QCA::CRL::operator!= | ( | const CRL & | other | ) | const`[inline]`

Inequality operator.

Parameters:

  | other | the CRL to be compared to this CRL

CRL& QCA::CRL::operator= | ( | const CRL & | from | ) |

Standard assignment operator.

Parameters:

  | from | the revocation list to assign from

bool QCA::CRL::operator== | ( | const CRL & | a | ) | const

Test for equality of two Certificate Revocation Lists.

Parameters:

  | a | the CRL to be compared to this CRL

Returns:
  true if the two CRLs are the same

QList<CRLEntry> QCA::CRL::revoked | ( |  | ) | const

a list of the revoked certificates in this CRL

SignatureAlgorithm QCA::CRL::signatureAlgorithm | ( |  | ) | const

The signature algorithm used for the signature on this CRL.

QDateTime QCA::CRL::thisUpdate | ( |  | ) | const

the time that this CRL became (or becomes) valid

QByteArray QCA::CRL::toDER | ( |  | ) | const

Export the Certificate Revocation List (CRL) in DER format.

Returns:
  an array containing the CRL in DER format

QString QCA::CRL::toPEM | ( |  | ) | const

Export the Certificate Revocation List (CRL) in PEM format.

Returns:
  a string containing the CRL in PEM format

bool QCA::CRL::toPEMFile | ( | const QString & | fileName | ) | const

Export the Certificate Revocation List (CRL) into PEM format in a file.

Parameters:

  | fileName | the name of the file to use

The documentation for this class was generated from the following file:

- qca_cert.h